<?php
namespace Teknisa\CADEST\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request\Filter;
use Teknisa\CADEST\Services\ComposicaoProdutoService;

class ComposicaoProduto  {
	protected $dataSourceManager;
	protected $environment;
    protected $entityManager;
    protected $service;

    public function __construct($dataSourceManager,$environment,$entityManager,ComposicaoProdutoService $service) {
	
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->service = $service;
	}
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filter = $request->getFilterCriteria()->getConditions();
        $params = self::getParamsAsArray($filter);
        $data = $this->service->find($params);
        $response->addDataSet(new DataSet('ger14600_composicao_do_produto', $data));
    }
    
    public function getParamsAsArray($filter) {
        $params = array();
        foreach($filter as $row){
            $params[$row['columnName']] = $row['value'];
        }
        return $params;
    }
}